import tkinter as tk
from tkinter import ttk
import pyqrcode
import navpoint.fix_path
import navpoint.usb


def choose_mode():
    def _usb_clicked():
        window.destroy()
        global mode
        mode = "usb"

    def _mobile_clicked():
        window.destroy()
        global mode
        mode = "mobile"

    window = tk.Tk(className="navpoint")
    window.title("Navpoint")
    window.resizable(width=False, height=False)

    global mode
    mode = ""

    ttk.Label(window, text="How should Navpoint obtain location data?").pack()
    usb_button = ttk.Button(
        window, text="USB GPS receiver (NMEA)", command=_usb_clicked
    )
    usb_button.pack()
    mobile_button = ttk.Button(
        window, text="Phone running Navpoint Mobile", command=_mobile_clicked
    )
    mobile_button.pack()

    try:
        window.iconbitmap(navpoint.fix_path.fix_path("icon.ico"))
    except tk.TclError:
        pass

    window.mainloop()
    return mode


def show_qr(link):
    window = tk.Tk(className="navpoint")
    window.title("Navpoint")
    window.resizable(width=False, height=False)

    label = tk.Label(window, text="QR code here...")
    label.pack()

    image = tk.BitmapImage(
        data=pyqrcode.create(link).xbm(scale=int(window.winfo_fpixels("2m")))
    )
    image.config(background="white")
    image.config(foreground="black")

    label.config(image=image)

    try:
        window.iconbitmap(navpoint.fix_path.fix_path("icon.ico"))
    except tk.TclError:
        pass

    window.mainloop()
